var SQRT_SIGN = "\u221A";

function CalcHelper() {

    this.create = function (inputComponent, formattedInput, input, _template) {
        var icon = ImageButton.createButton("calcIcon");

        icon.valign = "center";

        icon.src = IC.MasterDecorator.imagesPath + "/calcNormal.gif";
        icon.style.marginRight = "2px";
        icon.style.verticalAlign = "middle";

        icon.formattedInput = ICOpen._(formattedInput);
        icon.style.cursor = document.all?"hand":"pointer";
        this.template = _template;

        new Calc(inputComponent, icon, _template);

        return icon;
    };

    this.preload = function (_template){
        _template.preload();
    };
}

function Calc(component, btn, _template) {
    this.inputComponent = component;
    this.button = ICOpen._(ICOpen.$(btn));
    this.visible = false;
    this.calcDiv = null;
    this.attach();
    this.template = _template;

    this.X = null;
    this.Y = null;
    this._currentRegister = "X";
    this.operator = null;

    this.justRegistred = false;
    this.valueChangedAfterRegistered = false;

    this.memory = 0;

}

Calc.Z_INDEX = 30000;
Calc.calcs = [];

Calc.prototype.getCalcDiv = function() {
    return ICOpen.$(this.calcDiv);
};

Calc.prototype.getButton = function() {
    return ICOpen.$(this.button);
};


Calc.fnClick = function (e) {
    Event_preventDefault(e);
    this.calcCalled();
};

Calc.prototype.setValueChangedAfterRegistered = function (arg) {
    this.valueChangedAfterRegistered = arg;
};

Calc.prototype.attach = function() {
    Event_addListener(this.getButton(), "click", Calc.fnClick, this, true);
    if (Event_isIE)
        Event_addListener(this.getButton(), "dblclick", Calc.fnClick, this, true);

    Event_addListener(this.inputComponent.getElement(), "focus", function (e) {
        if (this.hideOthers())
            this.show();
    }, this, true);

    this.inputComponent.refiners.push({
        handleKeyDown : function (value, c, e) {
            if (c == 13 && this.calc.visible ) {
                this.calc.hide();
                Event_preventDefault(e);
                if (value!=null)
                    value.stopProcessing = true;
                this.calc._handleEQButton();
            } else if (c == 27) {
                if (this.calc.visible) {
                    this.calc.calcCalled();
                    if (value!=null)
                        value.stopProcessing = true;
                    Event_preventDefault(e);

                    this.calc.setValueChangedAfterRegistered(false);
                    this.calc.setJustRegistred(true);
                    this.calc.X = this.calc.Y = null;
                    this.calc._currentRegister = "X";
                    this.calc.operator = null;

                }
            }
        },
        handleCharEntered : function(value, c, e) {
            if (" ".charCodeAt(0) == c) {
                this.calc.calcCalled();
                if (value!=null)
                    value.stopProcessing = true;
                Event_preventDefault(e);
            } else if ("+".charCodeAt(0) == c ||
                       ("-".charCodeAt(0) == c && (value ==null || !value.isChangeSignCursorPos()) ) ||
                       "/".charCodeAt(0) == c ||
                       "*".charCodeAt(0) == c) {
                if (!this.calc.visible)
                    this.calc.show();
                Event_preventDefault(e);
                if (value!=null)
                    value.stopProcessing = true;
                this.calc._handleOperatorButton(String.fromCharCode(c));
            } else if ("=".charCodeAt(0) == c ) {
                if (!this.calc.visible)
                    this.calc.show();
                Event_preventDefault(e);
                if (value!=null)
                    value.stopProcessing = true;
                this.calc._handleEQButton();
            } else {
                this.calc.setValueChangedAfterRegistered(true);
            }
        },handleChange:function() {
            this.calc.setValueChangedAfterRegistered(true);
        }, calc:this });

    if (this.inputComponent.maskMgr && this.inputComponent.maskMgr.specialChars) {
        this.inputComponent.maskMgr.specialChars.push("+");
        this.inputComponent.maskMgr.specialChars.push("-");
        this.inputComponent.maskMgr.specialChars.push("*");
        this.inputComponent.maskMgr.specialChars.push("/");
        this.inputComponent.maskMgr.specialChars.push("=");
    }
};

Calc.prototype.calcCalled = function() {
    if (!this.visible)
        this.show();
    else
        this.hide();
};
Calc.prototype.show = function() {

    this.prepareDOM();
    this.getCalcDiv().style.display = "";

    if (window.CursorOnFocus)
        CursorOnFocus.lastPopUpButtonPressTimestamp = new Date().getTime();
    this.inputComponent.focus();

    this.visible = true;

    if (this.inputComponent.maskMgr){
        // strip ending ".000" and make sure they don't appear while calc is visible, unless user type some
        this.inputComponent.maskMgr.setIgnoreFixedDecimalPart(true);
        var val = this.inputComponent.getValue();
        var valBackup = val;
        while (val.length>0 && val.indexOf('.')!=-1) {
            var lastCh = val.charAt(val.length-1);
            if (lastCh=="0" || lastCh==".")
                val = val.substring(0, val.length-1);
            else
                break;
        }
        if (val !=valBackup){
            this.inputComponent.acceptNewValue(val);
        }
    }
};

Calc.prototype.hide = function() {
    this.getCalcDiv().style.display = "none";
    if (this.inputComponent.maskMgr){
        this.inputComponent.maskMgr.setIgnoreFixedDecimalPart(false);
        this.inputComponent.maskMgr.init();
    }
    this.visible = false;
};
Calc.prototype.prepareDOM = function() {
    if (this.getCalcDiv() == null) {

        var table = this.template.createDOM(this);

        var newCalcDiv = document.createElement("DIV");
        newCalcDiv.style.position = "absolute";
        newCalcDiv.style.zIndex = Calc.Z_INDEX;

        newCalcDiv.appendChild(table);

        ICOpen.Utils.attachToDocument(newCalcDiv);

        var dd = new_DD(ICOpen._(newCalcDiv));
        dd.calc = this;
        dd.endDrag = function() {
            if (window.CursorOnFocus)
                CursorOnFocus.lastPopUpButtonPressTimestamp = new Date().getTime();
            this.calc.inputComponent.focus();
        };

        Calc.calcs.push(this);
        ShowMaster.moveUnderRight(this.inputComponent.getElement(), newCalcDiv);

        this.calcDiv = ICOpen._(newCalcDiv);

        this.template.init();
    }
    this.hideOthers();
};

Calc.prototype.helpIconClicked = function (){
    IC.MasterDecorator.getHelpIconClickedFunction()();
};

Calc.prototype.positionIconClicked = function () {
    ShowMaster.moveUnderRight(this.inputComponent.getElement(), this.getCalcDiv(), true);
};

Calc.prototype.closeIconClicked = function () {
    this.hide();
};

Calc.prototype.hideOthers = function () {
    var res = false;
    for (var i = 0; i < Calc.calcs.length; i++) {
        if (Calc.calcs[i] != this && Calc.calcs[i].visible) {
            Calc.calcs[i].hide();
            res = true;
        }
    }
    return res;
};
Calc.prototype.getMemoryFormatted = function() {
    if (this.inputComponent.maskMgr){
        var value = new Value();
        value.entered = "" + this.memory;

        this.inputComponent.maskMgr.handleChange(value);
        return value.masked;
    } else {
        return this.memory; 
    }
};

Calc.prototype.calculate = function(_y) {
    this._saveToRegister();

    if (this.operator != null) {
        if (this.Y==null || this.Y.length == 0)
            this.Y = "0";
        if (this.X==null || this.X.length == 0)
            this.X = "0";

        var newVal = eval(parseFloat(this.X) + " " + this.operator + " " + parseFloat(this.Y));
        this.handleNewValue(newVal);
        this.inputComponent.acceptNewValue(newVal);
        this.setValueChangedAfterRegistered(false);
    }
};


Calc.prototype._handleEQButton = function() {
    this.calculate();
    this._currentRegister = "X";
    this._saveToRegister();

    this.setJustRegistred(true);
    this.setValueChangedAfterRegistered(false);
};

Calc.prototype.setJustRegistred = function(value) {
    this.justRegistred = value;
    if (value) {
        ICOpen.Utils.setSelectionRange(this.inputComponent.getElement(),0, 65535);
    }
};

Calc.prototype._saveToRegister = function(buttonValue) {
    if (!this.valueChangedAfterRegistered && this._currentRegister=="Y")
        return;
    if (this._currentRegister=="X")
        this.X = this.inputComponent.getParsedValue();
    else
        this.Y = this.inputComponent.getParsedValue();
};

Calc.prototype._handleOperatorButton = function(buttonValue) {

    if (this.valueChangedAfterRegistered)
        this.calculate();

    this._currentRegister = "X";
    this._saveToRegister();
    this.setValueChangedAfterRegistered(false);
    this.operator = buttonValue;
    this.setJustRegistred(true);
    this._currentRegister="Y";
};

Calc.prototype.getDecimalSeparator = function(buttonValue) {
    if (this.inputComponent.maskMgr)
        return this.inputComponent.maskMgr.decimalSeparator;
    else
        return ".";
};

Calc.prototype.buttonClicked = function(buttonValue) {

    buttonValue = buttonValue != null?buttonValue.toUpperCase():null;

    if (buttonValue == "&LARR;" || buttonValue == "BS") {
        this.inputComponent.acceptBackSpace();
    } else if (buttonValue == "1/X") {
        var x = this.inputComponent.getParsedValue();
        var newVal = eval("1/" + x);
        this.handleNewValue(newVal);
        this.inputComponent.acceptNewValue(newVal);

    } else if ((buttonValue >= "0" && buttonValue <= "9") || buttonValue == this.getDecimalSeparator()) {
        this.setValueChangedAfterRegistered(true);
        if (this.justRegistred) {
            this.justRegistred = false;
            this.inputComponent.acceptNewValue(buttonValue);
        } else
            this.inputComponent.acceptChar(buttonValue);
    } else if (buttonValue == "CE") {
        this.setValueChangedAfterRegistered(false);
        this.setJustRegistred(true);
        this.inputComponent.acceptNewValue(0);
    } else if (buttonValue == "+/-") {
        this.setValueChangedAfterRegistered(true);
        var val = this.inputComponent.getParsedValue()+"";
        if (val.length > 0 && val.charAt(0) == "-")
            val = val.substring(1);
        else
            val = "-" + val;
        this.inputComponent.acceptNewValue(val);
    } else if (buttonValue == "C") {
        this.setValueChangedAfterRegistered(false);
        this.setJustRegistred(true);
        this.inputComponent.acceptNewValue(0);
        this.X = this.Y = null;
        this._currentRegister = "X";
        this.operator = null;
    } else if (buttonValue == "=") {
        this._handleEQButton();
    } else if (buttonValue == "+" || buttonValue == "-" || buttonValue == "/" || buttonValue == "*") {
        this._handleOperatorButton(buttonValue);
    } else if (buttonValue == "M+" || buttonValue == "M-") {
        if (this.valueChangedAfterRegistered)
            this.calculate();
        this._currentRegister = "X";
        this.setValueChangedAfterRegistered(false);
        this.memory += (buttonValue == "M+"?1:-1) * this.inputComponent.getParsedValue();
        this.setJustRegistred(true);

    } else if (buttonValue == SQRT_SIGN || buttonValue == "SQRT") {
        this.setValueChangedAfterRegistered(false);
        this.setJustRegistred(true);
        var newValue = Math.sqrt(this.inputComponent.getParsedValue());
        this.handleNewValue(newValue);
        this.inputComponent.acceptNewValue(newValue);
    } else if (buttonValue == "%") {
        this.setValueChangedAfterRegistered(false);
        this.setJustRegistred(true);
        if (this.operator == "*") {
            this.calculate(this.inputComponent.getParsedValue() / 100);
        } else {
            this.inputComponent.acceptNewValue(this.X / 100 * this.inputComponent.getParsedValue());
        }

    } else if (buttonValue == "MR") {
        this.setValueChangedAfterRegistered(false);
        this.setJustRegistred(true);
        this.inputComponent.acceptNewValue(this.memory);
    } else if (buttonValue == "MC") {
        this.setValueChangedAfterRegistered(false);
        this.setJustRegistred(true);
        this.memory = 0;
    } else {
        ICOpen.Log.warn("button "+buttonValue+" is not implemented");
    }
    if (window.CursorOnFocus)
        CursorOnFocus.lastPopUpButtonPressTimestamp = new Date().getTime();
    this.inputComponent.focus();
};

Calc.prototype.handleNewValue = function(newVal) {
//    if (newVal != "" + parseInt(newVal))
//        this.inputComponent.showMessage(newVal, "blue");
// ??? is this needed?

};
