;
function CalcCSS(baseClassName) {
    this.className = baseClassName;

    // memory indicator stuff
    this.memoryToolTipBox = new ToolTipBox("CalcMemory");

    this.fShow = function() {
        this.template.memoryToolTipBox.showRight(this, "&nbsp;" + this.calc.getMemoryFormatted(), false);
    };

    this.fHide = function() {
        this.template.memoryToolTipBox.disappear(false);
    };

    this.fnRefreshToolTip = function () {
        var calc = this.calc;
        ICOpen.Utils.setTimeout(function() {
            new ToolTipBox('CalcMemory').getBox().innerHTML = "&nbsp;" + calc.getMemoryFormatted()
        }, 1);
    };
    // end of memory indicator stuff


    this.createDOM = function(calcObject) {
        var table = document.createElement("div");
        table.align="left";
        table.style.MozBoxSizing = "border-box";

        this.instanceId = (CalcCSS.counter++) + "_calcGeneric";
        this.calcObject = ICOpen._(calcObject);
        table.innerHTML = CalcCSS._html
                .replace(/\$\{id\}/g,this.instanceId)
                .replace(/\$\{baseClassName\}/g,this.className)
                .replace(/\$\{decimalSeparator\}/g,calcObject.getDecimalSeparator())
                .replace(/\$\{imgPath\}/g,IC.MasterDecorator.imagesPath);

        ICOpen.Utils.IE6_selectTag_workaround(table,0);

        return table;
    };

    this.attachListener = function (no, text, calcObject){
        var el = ICOpen.$('bt_'+no+"_"+text);
        Event_addListener(el.parentNode, "click", CalcCSS.buttonClickHandler, {listener:calcObject,text:text}, true);
        if (Event_isIE)
            Event_addListener(el.parentNode, "dblclick", CalcCSS.buttonClickHandler, {listener:calcObject,text:text}, true);
        this.attachButtonBehaviour(el.parentNode);

    };

    this.attachButtonBehaviour = function (td){
        Event_addListener(td, "mouseover", CalcCSS.doMouseOver);
        Event_addListener(td, "mouseout", CalcCSS.doMouseOut);
        Event_addListener(td, "mousedown", CalcCSS.doMouseDown);
        Event_addListener(td, "mouseup", CalcCSS.doMouseUp);
    };

    this.init = function (){
        var calcObject = ICOpen.$(this.calcObject);
        var labels = ["bs","c","ce","0","1","2","3","4","5","6","7","8","9","mr","mc","m+","m-",".","sqrt","*","%","/","-","+","1/x","+/-","="];
        for (var i=0;i<labels.length;i++)
            this.attachListener(this.instanceId,labels[i],calcObject);

        Event_addListener(ICOpen.$("bt_"+this.instanceId+"_help").parentNode, "click", calcObject.helpIconClicked, calcObject, true);

        if (IC.MasterDecorator.getHelpIconClickedFunction()==null){
            ICOpen.$("bt_"+this.instanceId+"_help").style.display="none";
        }

        Event_addListener(ICOpen.$("bt_"+this.instanceId+"_position").parentNode, "click", calcObject.positionIconClicked, calcObject, true);
        Event_addListener(ICOpen.$("bt_"+this.instanceId+"_close").parentNode, "click", calcObject.closeIconClicked, calcObject, true);

        this.attachButtonBehaviour(ICOpen.$("bt_"+this.instanceId+"_close").parentNode);
        this.attachButtonBehaviour(ICOpen.$("bt_"+this.instanceId+"_position").parentNode);
        this.attachButtonBehaviour(ICOpen.$("bt_"+this.instanceId+"_help").parentNode);

        var mButtons = [
                ICOpen.$("bt_"+this.instanceId+"_mc"),
                ICOpen.$("bt_"+this.instanceId+"_mr"),
                ICOpen.$("bt_"+this.instanceId+"_m+"),
                ICOpen.$("bt_"+this.instanceId+"_m-") ];

        for (var i = 0; i < mButtons.length; i++) {
            var mButton = mButtons[i];
            mButton.calc = calcObject;
            mButton.template = this;
            Event_addListener(mButton, "mouseover", this.fShow);
            Event_addListener(mButton, "click", this.fnRefreshToolTip);
            if (Event_isIE)
                Event_addListener(mButton, "dblclick", this.fnRefreshToolTip);

            Event_addListener(mButton, "mouseout", this.fHide);
        }

    };

    this.preload = function (){
        // todo : preload frmk
    };
};

CalcCSS.doMouseOver = function (){
    Dom_AddClass(this,"IC_genericCalcButtonOver");
};

CalcCSS.doMouseDown = function (){
    Dom_AddClass(this,"IC_genericCalcButtonDown");
};
CalcCSS.doMouseOut = function (){
    Dom_RemoveClass(this,"IC_genericCalcButtonOver");
    Dom_RemoveClass(this,"IC_genericCalcButtonDown");
};
CalcCSS.doMouseUp = function (){
    Dom_RemoveClass(this,"IC_genericCalcButtonDown");
};

CalcCSS.buttonClickHandler = function(e) {
    Event_preventDefault(e);
    this.listener.buttonClicked(this.text);
};

CalcCSS.counter=0;

CalcCSS._html= '<table class="${baseClassName}" cellpadding="0" cellspacing="0" border="0" onselectstart="return false">'+
'<tr>'+
'<td class=IC_genericCalcBody>'+
'<table cellpadding="0" cellspacing="1">'+
'<tr>'+
'<td class="IC_genericCalcButton IC_genericCalcBS"><div id="bt_${id}_bs">&lt;</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcC"><div id="bt_${id}_c">c</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcCE"><div id="bt_${id}_ce">ce</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcPanel" colspan=3 align="right">'+
'<table align="right" cellpadding="0" cellspacing="0" border="0">'+
'<tr>'+
'<td class="IC_genericCalcSmallButton"><div id="bt_${id}_help"><img height="11px" width="12px" src="${imgPath}/helpIcon.gif"></div></td>'+
'<td class="IC_genericCalcSmallButton"><div id="bt_${id}_position"><img height="11px" width="12px" src="${imgPath}/positionIcon.gif"></div></td>'+
'<td class="IC_genericCalcSmallButton"><div id="bt_${id}_close"><img height="11px" width="12px" src="${imgPath}/closeIcon.gif"></div></td>'+
'</tr>'+
'</table>'+
'</td>'+
'</tr>'+
'<tr>'+
'<td class="IC_genericCalcButton IC_genericCalcMC"><div id="bt_${id}_mc">mc</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDigit"><div id="bt_${id}_7">7</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDigit"><div id="bt_${id}_8">8</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDigit"><div id="bt_${id}_9">9</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDiv"><div id="bt_${id}_/">/</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcSqrt"><div id="bt_${id}_sqrt" >&#x221A;</div></td>'+
'</tr>'+
'<tr>'+
'<td class="IC_genericCalcButton IC_genericCalcMR"><div id="bt_${id}_mr" >mr</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDigit"><div id="bt_${id}_4" >4</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDigit"><div id="bt_${id}_5" >5</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDigit"><div id="bt_${id}_6" >6</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcMult"><div id="bt_${id}_*" >*</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcPercent"><div id="bt_${id}_%" >%</div></td>'+
'</tr>'+
'<tr>'+
'<td class="IC_genericCalcButton IC_genericCalcMM"><div id="bt_${id}_m-" >m-</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDigit"><div id="bt_${id}_1" >1</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDigit"><div id="bt_${id}_2" >2</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDigit"><div id="bt_${id}_3" >3</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcMinus"><div id="bt_${id}_-" >-</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalc1DivX"><div id="bt_${id}_1/x" >1/x</div></td>'+
'</tr>'+
'<tr>'+
'<td class="IC_genericCalcButton IC_genericCalcMP"><div id="bt_${id}_m+" >m+</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDigit"><div id="bt_${id}_0" >0</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcSign"><div id="bt_${id}_+/-" >+/-</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcDot"><div id="bt_${id}_." >${decimalSeparator}</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcPlus"><div id="bt_${id}_+" >+</div></td>'+
'<td class="IC_genericCalcButton IC_genericCalcEQ"><div id="bt_${id}_=" >=</div></td>'+
'</tr>'+
'</table>'+
'</td>'+
'</tr>'+
''+
'</table>';
// include
