/**
 This is the main class with static methods.
 */
IC.MasterDecorator = function () {

};
/** @ignore */
IC.MasterDecorator.CalcCSS_DefautClassName = "IC_genericCalc";

IC.MasterDecorator.defsById = {};
IC.MasterDecorator.defsByClassName = {};

    /** @ignore */
IC.MasterDecorator.processElement = function (input, def) {
    var finalDefinition = {
        className : null,
        align : null,
        id : null,
        type : null, // madatory
        calcTemplate : IC.MasterDecorator.CalcCSS_DefautClassName
    };

    ICOpen.Utils.copyProperties(IC.MasterDecorator.globals, finalDefinition);

    for (var i in def) {
        finalDefinition[i] = def[i];
    }

    var type = finalDefinition.type;

    if (ICOpen.Utils.startsWithIgnoreCase(type, "numeric") && type.indexOf("/c")!=-1) {
        var template = CalcFactory.createTemplate(finalDefinition.calcTemplate);

        ICOpen.Utils.markAsProcessed(input);

        var name = input.name;

        input.style.textAlign = (finalDefinition.align==null)?"right":finalDefinition.align;

        var inputComponent = new OICInputComponent(input);

        var parent_ = input.parentNode;
        var nobr = document.createElement("nobr");
        parent_.insertBefore(nobr, input);
        parent_.removeChild(input);
        nobr.appendChild(input);

        input.style.verticalAlign = "middle";
        input.style.marginRight = "2px";

        var h = new CalcHelper();
        var helperButton = h.create(inputComponent, input, input, template);
        h.preload(template);
        nobr.appendChild(helperButton);
    }
};

/**
 Allows a user set the javascript function to be called when users clicks on [?] icon of pop-up calculator
 */
IC.MasterDecorator.setCustomCalcHelpFunction = function(_function) {
    IC.MasterDecorator.customCalcHelp = _function;
};
/** @ignore */
IC.MasterDecorator.customCalcHelp = function () {
    alert("Open Input Components by WiseBlocks.com");
};

/** @ignore */
IC.MasterDecorator.imagesPath = "WiseBlocks_resources/img";
// default path to IC images

/**
 Sets the absolute or relative path to WiseBlocks resources directory. Default value is WiseBlocks_resources/img
 However, depending on you sitemap you might need to change it to "../WiseBlocks_resources/img" for example.
 */

IC.MasterDecorator.setImagesPath = function (_imagesPath) {
    IC.MasterDecorator.imagesPath = _imagesPath;
};

/** @ignore */
IC.MasterDecorator.getHelpIconClickedFunction = function () {
    return IC.MasterDecorator.customCalcHelp;
};

/**
 Feed a an Array of definitions to InputComponents Suite. Definitions will be processed after the page
 is loaded
 */
IC.MasterDecorator.process = function (definition) {

    if (definition instanceof Array) {
        for (var i = 0; i < definition.length; i++) {
            var def = definition[i];
            IC.MasterDecorator.saveDef(def);
        }
    } else if (typeof definition != "undefined" && definition != null) {
        IC.MasterDecorator.saveDef(definition);
    }

    if (IC.MasterDecorator.page_loaded)
        IC.MasterDecorator.doProcess();

};

/** @ignore */
IC.MasterDecorator.saveDef = function (def) {

    if (def.className != null) {
        IC.MasterDecorator.defsByClassName[def.className] = def;
    } else if (def.id != null) {
        IC.MasterDecorator.defsById [def.id] = def;
    } else {
        ICOpen.Log.error("className or id missing in the definition");
    }
};

/** @ignore */
IC.MasterDecorator.page_loaded = false;
/** @ignore */
IC.MasterDecorator.doProcess = function () {

    if (window["IC.MasterDecorator.planned"])
        return;

    IC.MasterDecorator.page_loaded = true;
    // process all classes
    var inputs = document.getElementsByTagName("input");

    IC.MasterDecorator.elByClassName = {};
    for (var i = 0; inputs != null && i < inputs.length; i++) {
        var inp = inputs[i];
        if (typeof inp.className != "undefined" && inp.className != null && inp.className.length > 0) {
            var classes = inp.className.split(" ");
            var def = {};
            var toProcess = false;
            for (var j = 0; j < classes.length; j++) {
                var c = classes[j];
                if (IC.MasterDecorator.defsByClassName[c]) {
                    toProcess = true;
                    ICOpen.Utils.copyProperties(IC.MasterDecorator.defsByClassName[c], def);
                }
            }
            if (IC.MasterDecorator.defsById[inp.id]) {
                ICOpen.Utils.copyProperties(IC.MasterDecorator.defsById[inp.id], def);
                toProcess = true;
            }
            if (toProcess)
                IC.MasterDecorator.processElement(inp, def);
        }
    }
    // run processing
    for (var i in IC.MasterDecorator.defsById) {
        if (ICOpen.$(i) != null)
            IC.MasterDecorator.processElement(ICOpen.$(i), IC.MasterDecorator.defsById[i]);
    }
};

IC.MasterDecorator.checkCssPresence = function () {
    try{
        if (window["IC.MasterDecorator.planned"])
            return;
        for (var s = 0; s < document.styleSheets.length; s++) {
            var ss = document.styleSheets[s];
            var rules = ss.rules?ss.rules:ss.cssRules;
            for (var j = 0; j < rules.length; j++) {
                if (rules[j].selectorText == ".toolTipBox")
                    return;
            }
        }
        ICOpen.Log.error("Open Input Components CSS not included. Make sure you have included <link rel=stylesheet type=text/css href='YOUR_PATH/WiseBlocks_resources/css/ICOpenCalculator-[VERSION].css' />");
    } catch(e) {}
};

if (typeof window["ICOpen.MasterDecorator.planned"] == "undefined") {
    Event_addListener(window, "load", IC.MasterDecorator.doProcess);
    Event_addListener(window, "load", IC.MasterDecorator.checkCssPresence);
    window["ICOpen.MasterDecorator.planned"] = true;
} else {
    ICOpen.Log.warn("Attention, looks like ICOpen scripts are inclused twise on the page.");
}

IC.MasterDecorator.process([{className : "IC_Calc", type : "numeric/calc"} ,
{className : "IC_Calc_WindowsXPLike", type : "numeric/calc", calcTemplate : "WindowsXPLike"} ,
{className : "IC_Calc_Windows95Like", type : "numeric/calc", calcTemplate : "Windows95Like"},
{className : "IC_Calc_WindowsVistaLike", type : "numeric/calc", calcTemplate : "WindowsVistaLike"} ]);
