function ToolTipBox(instanceName) {
    this.message = "";
    if (typeof instanceName == "undefined")
        instanceName = ICOpen_getUniqueId();

    this.instanceName = instanceName;
    this.box = ICOpen.$(instanceName + "_ToolTipBox");
    this.visible = false;
};

ToolTipBox.boxOnClick = function (){
    this.style.display = "none"
};
ToolTipBox.boxOnCompleteHide = function (){
    this.getBox().style.display = "none";
};
ToolTipBox.boxOnCompleteShow = function (){
    this.getBox().style.display = "block";
};
ToolTipBox.prototype.getBox= function(_message) {
    if (this.box == null) {
        var boxDiv = document.createElement("div");
        boxDiv.id = this.instanceName+ "_ToolTipBox";
        boxDiv.className = "toolTipBox";
        boxDiv.ToolTipBox = ICOpen._(this);

        boxDiv.onclick = ToolTipBox.boxOnClick;

        ICOpen.Utils.attachToDocument(boxDiv);
        this.box = ICOpen._(boxDiv);
    }
    return ICOpen.$(this.box);
};
ToolTipBox.prototype.appear = function(animate) {
    if (animate) {
        var attributes = {
            opacity: { from: 0.1, to: 0.8 }
        };
        Dom_setStyle(this.getBox(), 'opacity', 0);
        Dom_setStyle(this.getBox(), 'display', 'block');
        var anim = new_Motion(this.getBox(), attributes, 0.5, Easing_easeNone);
        anim.onComplete.subscribe(ToolTipBox.boxOnCompleteShow, this, true);
        anim.animate();
    } else {
        Dom_setStyle(this.getBox(), 'opacity', 0.8);
        Dom_setStyle(this.getBox(), 'display', 'block');
    }
    this.visible =true;

};

ToolTipBox.prototype.disappear = function(animate) {
    if (!this.visible)
        return;

    if (animate) {
        var attributes = {
            opacity: { to: 0 }
        };
        var anim = new_Motion(this.getBox(), attributes, 0.3, Easing_easeOut);
        anim.onComplete.subscribe(ToolTipBox.boxOnCompleteHide, this, true);
        anim.animate();
    } else {
        Dom_setStyle(this.getBox(), 'opacity', 0);
        Dom_setStyle(this.getBox(), 'display', 'none');
    }

    this.visible =false;
};
ToolTipBox.prototype.initialize = function (_message,color) {

    if (color)
        this.getBox().style.color = color;
    this.getBox().style.display = "none";
    this.message = _message;
    this.getBox().innerHTML = this.message;
    this.visible = false;
};

ToolTipBox.prototype.showUnder= function (component, message,color, animate) {
    this.initialize(message,color);
    this.appear(animate);
    ShowMaster.moveUnderRight(component,this.getBox());
};

ToolTipBox.prototype.showAbove= function (component, message,color, animate) {
    this.initialize(message,color);
    this.appear(animate);
    ShowMaster.moveAbove(component,this.getBox());
};

ToolTipBox.prototype.showRight= function (component, message,color, animate) {
    this.initialize(message,color);
    this.appear(animate);
    ShowMaster.moveRight(component,this.getBox());
};

var toolTipBox = new ToolTipBox("default");